<CFSETTING ENABLECFOUTPUTONLY="Yes">

<!--- 
|| BEGIN FUSEDOC ||

|| DESCRIPTION || 
I parse data-file and create CF SESSION-scope structures,...
...unless structures are already present and current

|| DESIGNER ||
hal.helms@TeamAllaire.com
Amended by Lee Bjork Borkman (bjork@bjork.net) to use structures instead of a database, and to separate "menu" links 15 Feb 2001

|| PROGRAMMER ||
hal.helms@TeamAllaire.com
Amended by Lee Bjork Borkman (bjork@bjork.net) to use structures instead of a database, and to separate "menu" links 15 Feb 2001


|| END FUSEDOC ||
--->

<!---
<FUSEDOC>
    <IO>
        <IN>
            <boolean NAME="refresh" SCOPE="Request" COMMENTS="Do we force a re-parse?"/>
            <String NAME="wireframename" SCOPE="Attributes"/> 
            <String NAME="wireframedir" SCOPE="Attributes" COMMENTS="Relative to the wireframetool's install directory/> 
        </IN>
        <OUT>
            <STRUCTURE NAME="~wireframename~" SCOPE="Session" COMMENTS="A structure with same name as wireframe to hold parsed data">
                <LIST NAME="PL" COMMENTS="Page List: A list of PageState names in order as they appear in data"/>
                <STRING NAME="DF" COMMENTS="Data File: The contents of the text data-file (minus changeDescription data)"/>
                <STRUCTURE NAME="~pagestate~" COMMENTS="One structure for each pageState">
                    <STRING NAME="text" COMMENTS="The displayed name of the pageState (can include difficult characters, etc)">
                    <ARRAY NAME="content" COMMENTS="1 element per description block (usually 1 only)">
                        <STRUCTURE>
                            <STRING NAME="Display" COMMENTS="The title of the description block"/>
                            <STRING NAME="Content" COMMENTS="The text of the description block"/>
                        </STRUCTURE>
                    </ARRAY>
                    <ARRAY NAME="link" COMMENTS="1 element per Exit=Destination pair">
                        <STRUCTURE>
                            <STRING NAME="display" COMMENTS="The text for an Exit"/>
                            <STRING NAME="RFADisplay" COMMENTS="The text for a Destination (RFA originally meant ReturnFuseAction"/>
                            <STRING NAME="RFA" COMMENTS="The name of a Destination pageState"/>
                        </STRUCTURE>
                    </ARRAY>
                </STRUCTURE>
            </STRUCTURE>
        </OUT>
    </IO>
</FUSEDOC>
--->


<!--- @COMMENT: For testing purposes; may be removed for production --->
<cfparam name="attributes.refresh" default="false">

<CFLOCK TIMEOUT="60" THROWONTIMEOUT="Yes" TYPE="EXCLUSIVE" SCOPE="session">

<CFIF NOT isdefined("session.#attributes.wireframeName#") OR (attributes.refresh IS "true")>
	<cftry>
	<cffile action="READ" file="#attributes.fullwireframedir##request.os.delimiter##attributes.wireframename#.wir" variable="fileString">
	<CFSET fileString=rereplace(fileString, "\[\[\:changedescription\:\]\].*", "")>
	<CFSET fileString=rereplace(fileString, "[#chr(10)##chr(13)#][#chr(10)##chr(13)#]", "#chr(10)#", "all")>
	<CFSET fileString=rereplace(fileString, "#chr(10)#\-+#chr(10)#", "#chr(10)#", "all")>
	
		<cfcatch>
			<CFOUTPUT>Couldn't find the application's wireframe specification file, "#attributes.fullwireframedir##request.os.delimiter##attributes.wireframename#.wir".</CFOUTPUT>
			<cfabort>
		</cfcatch>
	</cftry>
	<CFIF isdefined("session.#attributes.wireframeName#")>
		<CFSET tmp = evaluate("StructClear(session.#attributes.wireframename#)")>
	</CFIF>
	<CFSET "session.#attributes.wireframename#" = StructNew()>
	<CFSET "session.#attributes.wireframename#.pl" = "">
	<!--- @COMMENT: Read in the wireframe specification file. --->
	
	<CFSET "session.#attributes.wireframeName#.df" = fileString>
	
	<!--- create an array to hold faIncludes --->
	<cfset faIncludes = ArrayNew(2)>
	
	<!--- loop over the entire file --->
	<cfloop list="#fileString#" index="aLine" delimiters="#chr(10)#">
		<!--- if i find a fuseaction, mark it --->
		<cfif Left( Trim( aLine ), 1 ) is "[">
			<cfset fa = ReplaceList( trim(aLine), '[,]', '' )>
			<CFSET fatext = fa>
			<CFSET fa = 'p_#rereplace(fa, "[^a-zA-Z0-9_]", "_", "all")#'>
			<CFSET tmp = evaluate("session.#attributes.wireframename#.#fa# = StructNew()")>
			<CFSET tmp = evaluate("structinsert(session.#attributes.wireframename#.#fa#, 'text', fatext)")>
			<CFSET tmp = evaluate("structinsert(session.#attributes.wireframename#.#fa#, 'content', ArrayNew(1))")>
			<CFSET tmp = evaluate("structinsert(session.#attributes.wireframename#.#fa#, 'link', ArrayNew(1))")>
			<CFSET "session.#attributes.wireframeName#.pl" = ListAppend(evaluate("session." & attributes.wireframeName & ".pl"), fa)>
		</cfif>
		
	<!--- as long as i'm in the same fa, find the elements and enter them into the database --->
		<!--- get rid of the line break --->
		<cfset aLine = REReplace( aLine, '#chr(10)#', '', 'ALL' )>
		
		<!--- if i don't find a new fa --->
		<cfif NOT REFindNoCase( '[\[{]', aLine )>
			
			<!--- and if i'm not in an include section --->
			<cfif REFind( '[=:]', aLine ) OR left(aLine, 1) IS ';'>
			
				<!--- include any RFAs --->
				<cfif left(aLine, 16) IS NOT 'Responsibilities' AND left(aLine, 11) IS NOT 'Description'AND left(aLine, 1) IS NOT ';'>
					<CFSET tmp = evaluate("ArrayAppend(session.#attributes.wireframename#.#fa#.link, StructNew())")>
					<CFSET index = evaluate ("ArrayLen(session.#attributes.wireframename#.#fa#.link)")>
					<CFSET displayString = Trim( GetToken( aLine, 1, ':=' ) )>
					<CFSET displayString = replace(displayString , "'", "''", "all")>
					<CFSET tmp = evaluate("structinsert(session.#attributes.wireframename#.#fa#.link[#index#], 'display', '#displayString#')")>
					<CFSET destination = Trim(GetToken(aLine, 2, ':='))>
					<CFSET prefix="">
					<CFIF ListLen(destination, ".") GT 1>
						<CFSET prefix = ListFirst(destination, ".")>
						<CFSET destination = ListDeleteAt(destination, 1, ".")>
					</CFIF>
					
					<CFSET destinationDisplay = destination>
					<CFSET destination = 'p_#rereplace(destination, "[^a-zA-Z0-9_]", "_", "all")#'>
					<CFIF len(prefix)>
						<CFSET destination = "#prefix#.#destination#">
					</CFIF>
	
					<CFSET tmp = evaluate("structinsert(session.#attributes.wireframename#.#fa#.link[#index#], 'RFA', '#destination#')")>
					<CFSET destinationDisplay=replace(destinationDisplay,"'", "", "all")>
					<CFSET destinationDisplay=replace(destinationDisplay,'"', "", "all")>
					<CFSET tmp = evaluate("structinsert(session.#attributes.wireframename#.#fa#.link[#index#], 'RFAdisplay', '#destinationDisplay#')")>
					
				<!--- or include any responsibilities --->
				<cfelse>
					<CFSET tmp = evaluate("ArrayAppend(session.#attributes.wireframename#.#fa#.content, StructNew())")>
					<CFSET index = evaluate ("ArrayLen(session.#attributes.wireframename#.#fa#.content)")>
					<CFIF left(aLine, 1) IS ';'>
						<CFSET displayString = "Comment">
					<CFELSE>
						<CFSET displayString = Trim( GetToken( aLine, 1, ':=' ) )>
						<CFSET displayString = replace(displayString , "'", "''", "all")>
					</CFIF>
					<CFSET tmp = evaluate("structinsert(session.#attributes.wireframename#.#fa#.content[#index#], 'display', '#displayString#')")>
					<CFIF left(aLine, 1) IS ';'>
						<CFSET displayString = replace(aline, ";", "")>
					<CFELSE>
						<CFSET displayString = Trim( GetToken( aLine, 2, ':=' ) )>
					</CFIF>
					<CFSET displayString = replace(displayString , "'", "''", "all")>
					<CFSET tmp = evaluate("structinsert(session.#attributes.wireframename#.#fa#.content[#index#], 'content', '#DisplayString#')")>
					
					
				</cfif> <!--- /include RFAs or responsibilities --->
			<cfelse> <!--- /if i'm not in an include section --->
				<cfif GetToken( aLine, 1, ' ' ) is "include">
					<cfset nextRow = Evaluate( ArrayLen( faIncludes ) + 1 )>
					<cfset faIncludes[nextRow][1] =  fa >
					<cfset faIncludes[nextRow][2] =  GetToken( aLine, 2, ' ' )>
				</cfif>
			</cfif> <!--- /if i'm not in an include section --->
		</cfif> <!--- /if i don't find a new fa --->
	</cfloop>
	
</CFIF>

</CFLOCK>
	
<CFSETTING ENABLECFOUTPUTONLY="No">


<!---
  $Log: act_checkdata.cfm,v $
  Revision 1.5  2001/08/22 13:58:56  leeborkman
  Removed the extraneous copy of the XML spec

  Revision 1.4  2001/08/22 13:49:47  leeborkman
  Added a first XML-FuseDoc spec for the current data-structure.  The data-structure obviously needs improving, or at least some more meaningful names.

  Revision 1.3  2001/08/21 13:26:58  leeborkman
  Added CVS Log block to the bottom of each file

--->