<CFSETTING ENABLECFOUTPUTONLY="No">

<!---
|| BEGIN FUSEDOC ||

|| LEGAL ||
This software is distributed under the GNU GENERAL PUBLIC LICENSE.
A copy of the GNU GENERAL PUBLIC LICENSE can be found in the accompanying license.txt file.

|| RESPONSIBILITIES ||
Main FuseBox for WireFrame Viewer/editor app

|| DESIGNER ||
Lee Bjork Borkman (bjork@bjork.net)

|| PROGRAMMER ||
Lee Bjork Borkman (bjork@bjork.net)

|| ATTRIBUTES ||
--> [FuseAction]


|| END FUSEDOC ||
--->



<cfinclude template="config/app_globals.cfm">

<!--- Build the page body --->
<CFMODULE TEMPLATE="bodycontent.cfm">

	<cfparam name="attributes.fuseaction" default="quickmap">

	<!--- Handle FuseActions --->
	<cfswitch expression="#attributes.fuseaction#">

		<!---@ FuseAction: quickmap:  --->
		<CFCASE VALUE="quickmap">
			<CFSET request.page.subtitle='"#attributes.wireframename#"'>
			<CFINCLUDE TEMPLATE="act_checkdata.cfm">
			<CFINCLUDE TEMPLATE="out_quickmap.cfm">
		</CFCASE>

		<!---@ FuseAction: generate  --->
		<CFCASE VALUE="generate">
			<CFSET request.page.subtitle='FuseBox Code: "#attributes.wireframename#"'>
			<CFINCLUDE TEMPLATE="act_checkdata.cfm">
			<CFINCLUDE TEMPLATE="out_switchblock.cfm">
		</CFCASE>

		<!---@ FuseAction: previewVersion:  --->
		<CFCASE VALUE="previewVersion">
			<CFSET request.page.subtitle='"Preview - #attributes.wireframename#"'>
			<cfset request.page.header="">
			<CFINCLUDE TEMPLATE="act_checkdata.cfm">
			<CFSET ATTRIBUTES.doLinks="false">
			<CFINCLUDE TEMPLATE="out_quickmap.cfm">
		</CFCASE>

		<!---@ FuseAction: showpage:  --->
		<CFCASE VALUE="showpage">
			<CFSET request.page.subtitle='"#attributes.wireframename#"'>
			<CFINCLUDE TEMPLATE="act_checkdata.cfm">
			<CFINCLUDE TEMPLATE="out_pagestate.cfm">
		</CFCASE>

		<!---@ FuseAction: editform:  --->
		<CFCASE VALUE="editform">
			<CFSET request.page.subtitle='Edit data - "#attributes.wireframename#"'>
			<CFINCLUDE TEMPLATE="act_checkdata.cfm">
			<CFINCLUDE TEMPLATE="in_datafile.cfm">
		</CFCASE>

		<!---@ FuseAction: processnewdata:  --->
		<CFCASE VALUE="processnewdata">
			<CFINCLUDE TEMPLATE="act_archivedata.cfm">
			<CFINCLUDE TEMPLATE="act_savenewdata.cfm">
			<CFSET ATTRIBUTES.refresh = true>
			<CFINCLUDE TEMPLATE="act_checkdata.cfm">
			<CFLOCATION URL="#self#?wireframename=#attributes.wireframename#&wireframedir=#attributes.wireframedir#">
		</CFCASE>

		<!---@ FuseAction: history:  --->
		<CFCASE VALUE="history">
			<CFSET request.page.subtitle='Version History - "#attributes.wireframename#"'>
			<CFINCLUDE TEMPLATE="sel_history.cfm">
			<CFINCLUDE TEMPLATE="act_getdescriptions.cfm">
			<CFINCLUDE TEMPLATE="out_history.cfm">
		</CFCASE>

		<!---@ FuseAction: revert:  --->
		<CFCASE VALUE="revert">
			<CFINCLUDE TEMPLATE="act_archivedata.cfm">
			<CFINCLUDE TEMPLATE="act_saveolddata.cfm">
			<CFSET ATTRIBUTES.refresh = true>
			<CFINCLUDE TEMPLATE="act_checkdata.cfm">
			<CFLOCATION URL="#self#?wireframename=#attributes.wireframename#&wireframedir=#attributes.wireframedir#">
		</CFCASE>

		<!---@ FuseAction: delete:  --->
		<CFCASE VALUE="delete">
			<CFINCLUDE TEMPLATE="act_deletedata.cfm">
			<CFLOCATION URL="#self#?fuseaction=history&wireframename=#attributes.wireframename#&wireframedir=#attributes.wireframedir#">
		</CFCASE>

		<!---@ FuseAction: help:  --->
		<CFCASE VALUE="help">
			<CFSET request.page.subtitle='Help'>
			<CFINCLUDE TEMPLATE="out_help.cfm">
		</CFCASE>

		<!---@ FuseAction: credits:  --->
		<CFCASE VALUE="credits">
			<CFSET request.page.subtitle='Credits'>
			<CFINCLUDE TEMPLATE="out_credits.cfm">
		</CFCASE>

		<!---@ FuseAction: selectorcreateform:  --->
		<CFCASE VALUE="selectorcreateform">
			<CFMODULE TEMPLATE="index.cfm" FUSEACTION="selectwireframe" SHOWHEADERS="false">
			<CFMODULE TEMPLATE="index.cfm" FUSEACTION="createnew" SHOWHEADERS="false">
			<CFSET request.page.subtitle='Select or Create WireFrame'>
		</CFCASE>

		<!--- Fuseactions added by John Beynon --->

		<cfcase value="admin">
		<cfset request.page.subtitle='Wireframe Administration'>
		<cfinclude template="out_admin.cfm">
		</cfcase>

		<cfcase value="selectwireframe">
		<CFSET request.page.subtitle='Wireframes available'>
		<CFINCLUDE TEMPLATE="out_wirelist.cfm">
		</cfcase>

		<cfcase value="createnew">
		<CFSET request.page.subtitle='Create new wireframe'>
		<cfinclude template="out_createwire.cfm">
		</cfcase>

		<cfcase value="createnewwireframe">
		<cfinclude template="act_createwireframe.cfm">
		</cfcase>


		<!---@ FuseAction: throwerror:  --->
		<CFCASE VALUE="throwerror">
				<CFTHROW MESSAGE="Test Error">
		</CFCASE>


		<cfdefaultcase>
		</cfdefaultcase>

	</cfswitch>

</CFMODULE>

<!--- Display the page --->
<cfinclude template="config/app_layout.cfm">

<CFSETTING ENABLECFOUTPUTONLY="No">

<!---
$Log: index.cfm,v $
Revision 1.7  2001/09/07 06:27:33  leeborkman
Added selectorcreateform fuseaction (a recursive call to two Admin functions)

Revision 1.6  2001/09/06 14:13:34  jabeynon
amended files adding ADMIN section to out_smallmenu.cfm to allow selecting and deleting of Wireframes

--->
