<CFSETTING ENABLECFOUTPUTONLY="Yes">
<!--- 
|| BEGIN FUSEDOC ||

|| DESCRIPTION || 
I take the CF structures and display a basic "map" of the wireframe.
I also display a form to edit the underlying datafile.

|| DESIGNER ||
Lee Bjork Borkman (bjork@bjork.net)

|| PROGRAMMER ||
hal.helms@TeamAllaire.com
Amended by Lee Bjork Borkman (bjork@bjork.net) to use structures instead of a database, and to separate "menu" links 15 Feb 2001

|| ATTRIBUTES ||
--> wireframename: 
--> doLinks: make links for navigating?  Default is "true"

|| VERSION HISTORY ||
23 Feb 2001: Initial Version
19 April 2001: Amended for use of special chars in page names,
  and to stop exposing full server paths
21 April 2001: Better Map - CustomTags included in top directory for easy install
22 April 2001: CFLOCK around session variables

|| END FUSEDOC ||
--->

<CFPARAM NAME="ATTRIBUTES.doLinks" DEFAULT="true">

<CFLOCK TIMEOUT="60" THROWONTIMEOUT="Yes" TYPE="EXCLUSIVE" SCOPE="session">

<CFOUTPUT>
<H2>Quick Map of "#attributes.wireframename#"</H2>

<TABLE BORDER=1 WIDTH=#request.page.width# CELLSPACING=0 CELLPADDING=3>
<TR><TH WIDTH=35%>Page</TH><TH WIDTH=65%>Exits and Destinations</TH></TR>
<!--- @PDL: For each PageState --->
<CFLOOP INDEX="pagestate" LIST="#evaluate("session." & attributes.wireframeName & ".pl")#">
	<CFIF pageState IS NOT "df">
		<TR>
		<TD>
		<!--- @PDL: +Show PageState name (hyperlinked)--->
		<CFSET pagedisplayname = evaluate("session." & attributes.wireframename & "." & pagestate & ".text")>

		<CFIF ATTRIBUTES.doLinks>
			<A HREF="#self#?fuseaction=showpage&page=#pagestate#&wireframename=#attributes.wireframename#&wireframedir=#attributes.wireframedir#"><B>#pagedisplayname#</B></A>
		<CFELSE>
			<B>#pagedisplayname#</B>
		</CFIF>

		<CFTRY>
			<CFSET content=evaluate("session.#Attributes.wireframename#.#pagestate#.content[1].content")>
			<CFSET content=replace(content, "''", "'", "all")>
			<CFSET display=evaluate("session.#Attributes.wireframename#.#pagestate#.content[1].display")>
			<CFSET display=replace(display, "''", "'", "all")>
			<CFCATCH TYPE="expression"><!--- No content for the page ---></CFCATCH>
		</CFTRY>
		<BR><FONT SIZE=-2>#content#</FONT>

		</TD>
		<TD>
			<TABLE BORDER=0 WIDTH=100% CELLSPACING=1 CELLPADDING=1>
				<!--- @PDL: +For each Link --->
				<CFSET menuStarted = false>
				<CFLOOP INDEX="link" FROM="1" TO="#evaluate("arraylen(session." & attributes.wireframename & "." & pagestate & ".link)")#">
					<CFSET displayText = rereplace(evaluate("session." & attributes.wireframename & "." & pagestate & ".link[" & link & "].display"), "([^\.]+)\.", "\1: ")>
					<CFIF left(displayText, 6) IS "menu: ">
						<CFSET displayText = replacenocase(displayText, "menu: ", "")>
						<CFIF NOT menuStarted>
							<CFSET menuStarted = true>
							<TR><TD colspane=3>--------------------------------</TD></TR>
						</CFIF>
					</CFIF>
				<TR>
					<TD WIDTH=45%><FONT SIZE=-2>#displayText#</TD>
					<TD WIDTH=10%>--></TD>
					<CFSET extra_text = "">
					<CFSET destination_code = #evaluate("session." & attributes.wireframename & "." & pagestate & ".link[" & link & "].RFA")#>
					<CFSET destination_text = #evaluate("session." & attributes.wireframename & "." & pagestate & ".link[" & link & "].RFAdisplay")#>
					<CFTRY>
						<CFSET tmp = #evaluate("session." & attributes.wireframename & "." & destination_code & ".text")#>
						<CFCATCH TYPE=expression><!--- Destination page not yet defined ---><CFSET extra_text="&nbsp;&nbsp;<I>[undef.]</I>"></CFCATCH>
					</CFTRY>
					<TD WIDTH=45%><FONT SIZE=-2><CFIF ATTRIBUTES.doLinks><A HREF="#self#?fuseaction=showpage&page=#destination_code#&wireframename=#attributes.wireframename#&wireframedir=#attributes.wireframedir#"><FONT SIZE=-2>#destination_text##extra_text#</A><CFELSE><FONT SIZE=-2>#destination_text##extra_text#</CFIF></TD>
				</TR>
				<!--- @PDL: +Next Link --->
				</CFLOOP>
			</TABLE>
		</FONT>
		</TD>
		</TR>
		</CFIF>
<!--- @PDL: Next PageState --->
</CFLOOP>
</TABLE><P>
</CFOUTPUT>

</CFLOCK>
	
<CFSETTING ENABLECFOUTPUTONLY="No">


<!---
  $Log: out_quickmap.cfm,v $
  Revision 1.3  2001/08/21 13:26:58  leeborkman
  Added CVS Log block to the bottom of each file

--->