<CFSETTING ENABLECFOUTPUTONLY="Yes">
<!--- 
|| BEGIN FUSEDOC ||

|| DESCRIPTION || 
I take the CF structures and display a basic FuseBox CFSWITCH block

|| DESIGNER ||
Lee Bjork Borkman (bjork@bjork.net)

|| PROGRAMMER ||
hal.helms@TeamAllaire.com
Amended by Lee Bjork Borkman (bjork@bjork.net) to use structures instead of a database, and to separate "menu" links 15 Feb 2001

|| ATTRIBUTES ||
--> wireframename: 

|| VERSION HISTORY ||
30 May 2001: Initial Version by Lee Borkman


|| END FUSEDOC ||
--->


<CFLOCK TIMEOUT="60" THROWONTIMEOUT="Yes" TYPE="EXCLUSIVE">


<!--- Display start of CFSWITCH --->
<CFOUTPUT><PRE>
&lt;CFSWITCH EXPRESSION="##attributes.fuseaction##"&gt;
</CFOUTPUT>
<CFSET firstAction=true>
<!--- @PDL: For each PageState --->
<CFLOOP INDEX="pagestate" LIST="#evaluate("session." & attributes.wireframeName & ".pl")#">
	<CFIF pageState IS NOT "df">

		<CFSET pagedisplayname = evaluate("session." & attributes.wireframename & "." & pagestate & ".text")>
		
		<!--- Get usable FuseAction name --->
		<CFSET fuseactionName = rereplace(pagedisplayname, "[']", "", "all")>
		<CFSET fuseactionName = rereplace(fuseactionName, '["]', "", "all")>
		<CFSET fuseactionName = rereplace(fuseactionName, "[^a-zA-Z0-9_]", "_", "all")>
		<CFSET fuseactionName = rereplace(fuseactionName, "_+", "_", "all")>

		<!--- @PDL: +Show PageState name (hyperlinked)--->
	<CFOUTPUT>
	&lt;CFCASE VALUE="#fuseactionName#<CFIF firstAction>,default<CFSET firstAction=false></CFIF>"&gt;
</CFOUTPUT>
		
		<CFTRY>
			<CFSET content=evaluate("session.#Attributes.wireframename#.#pagestate#.content[1].content")>
			<CFSET content=replace(content, "''", "'", "all")>
			<CFSET display=evaluate("session.#Attributes.wireframename#.#pagestate#.content[1].display")>
			<CFSET display=replace(display, "''", "'", "all")>
			<CFCATCH TYPE="expression"><!--- No content for the page ---></CFCATCH>
		</CFTRY>
		
		

	<CFOUTPUT>	&lt;!---@FuseAction: #fuseactionName#: #content# ---&gt;
</CFOUTPUT>
	<CFOUTPUT>		&lt;CFOUTPUT&gt;#content#&lt;P&gt;&lt;/CFOUTPUT&gt;
</CFOUTPUT>
				<!--- @PDL: +For each Link --->
				<CFLOOP INDEX="link" FROM="1" TO="#evaluate("arraylen(session." & attributes.wireframename & "." & pagestate & ".link)")#">
					<CFSET displayText = rereplace(evaluate("session." & attributes.wireframename & "." & pagestate & ".link[" & link & "].display"), "([^\.]+)\.", "\1: ")>
					<CFIF left(displayText, 6) IS "menu: ">
						<CFBREAK>
					</CFIF>
					<CFSET extra_text = "">
					<CFSET destination_code = #evaluate("session." & attributes.wireframename & "." & pagestate & ".link[" & link & "].RFA")#>
					<CFSET destination_text = #evaluate("session." & attributes.wireframename & "." & pagestate & ".link[" & link & "].RFAdisplay")#>
					<CFTRY>
						<CFSET tmp = #evaluate("session." & attributes.wireframename & "." & destination_code & ".text")#>
						<CFCATCH TYPE=expression><!--- Destination page not yet defined ---><CFSET extra_text="&nbsp;&nbsp;<I>[undef.]</I>"></CFCATCH>
					</CFTRY>
					<CFSET displayText = rereplace(displayText, "[']", "", "all")>
					<CFSET displayText = rereplace(displayText, '["]', "", "all")>
					<CFSET displayText = rereplace(displayText, "[^a-zA-Z0-9_]", "_", "all")>
					<CFSET displayText = rereplace(displayText, "_+", "_", "all")>

					<CFSET destination_text = rereplace(destination_text, "[']", "", "all")>
					<CFSET destination_text = rereplace(destination_text, '["]', "", "all")>
					<CFSET destination_text = rereplace(destination_text, "[^a-zA-Z0-9_]", "_", "all")>
					<CFSET destination_text = rereplace(destination_text, "_+", "_", "all")>

					<CFOUTPUT>		&lt;CFSET request.XFA.#displayText# = "#attributes.wireframename#.#destination_text#"&gt;
</CFOUTPUT>
				<!--- @PDL: +Next Link --->
				</CFLOOP>
				
				<CFOUTPUT>
		&lt;CFOUTPUT&gt;
</CFOUTPUT>
				
				<!--- @PDL: +For each Link --->
				<CFLOOP INDEX="link" FROM="1" TO="#evaluate("arraylen(session." & attributes.wireframename & "." & pagestate & ".link)")#">
					<CFSET displayText = rereplace(evaluate("session." & attributes.wireframename & "." & pagestate & ".link[" & link & "].display"), "([^\.]+)\.", "\1: ")>
					<CFSET displayOriginal = displayText>
					<CFIF left(displayText, 6) IS "menu: ">
						<CFBREAK>
					</CFIF>
					<CFSET extra_text = "">
					<CFSET destination_code = #evaluate("session." & attributes.wireframename & "." & pagestate & ".link[" & link & "].RFA")#>
					<CFSET destination_text = #evaluate("session." & attributes.wireframename & "." & pagestate & ".link[" & link & "].RFAdisplay")#>
					<CFTRY>
						<CFSET tmp = #evaluate("session." & attributes.wireframename & "." & destination_code & ".text")#>
						<CFCATCH TYPE=expression><!--- Destination page not yet defined ---><CFSET extra_text="&nbsp;&nbsp;<I>[undef.]</I>"></CFCATCH>
					</CFTRY>

					<CFSET displayText = rereplace(displayText, "[']", "", "all")>
					<CFSET displayText = rereplace(displayText, '["]', "", "all")>
					<CFSET displayText = rereplace(displayText, "[^a-zA-Z0-9_]", "_", "all")>
					<CFSET displayText = rereplace(displayText, "_+", "_", "all")>

					<CFSET destination_text = rereplace(destination_text, "[']", "", "all")>
					<CFSET destination_text = rereplace(destination_text, '["]', "", "all")>
					<CFSET destination_text = rereplace(destination_text, "[^a-zA-Z0-9_]", "_", "all")>
					<CFSET destination_text = rereplace(destination_text, "_+", "_", "all")>

					<CFOUTPUT>			&lt;A HREF="index.cfm?fuseaction=##request.XFA.#displaytext###"&gt;#displayOriginal#&lt;/A&gt;&lt;BR&gt;
</CFOUTPUT>
				<!--- @PDL: +Next Link --->
				</CFLOOP>
				<CFOUTPUT>		&lt;/CFOUTPUT&gt;
</CFOUTPUT>

			<CFOUTPUT>
		&lt;CFSET request.page.subtitle = "#pagedisplayname#"&gt;
</CFOUTPUT>	


		<CFOUTPUT>	&lt;/CFCASE&gt;

</CFOUTPUT>


		</CFIF>
<!--- @PDL: Next PageState --->
</CFLOOP>
<!--- Display end of CFSWITCH --->
<CFOUTPUT>	&lt;cfdefaultcase&gt;
		&lt;CFSET request.error.type="Unknown Action"&gt;
		&lt;CFSET request.error.message='Action "##attributes.original_fuseaction##" unknown.'&gt;
		&lt;CFTHROW&gt;
	&lt;/cfdefaultcase&gt;

&lt;/CFSWITCH&gt;
</PRE></CFOUTPUT>


</CFLOCK>
	
<CFSETTING ENABLECFOUTPUTONLY="No">


<!---
  $Log: out_switchblock.cfm,v $
  Revision 1.2  2001/08/21 13:26:58  leeborkman
  Added CVS Log block to the bottom of each file

--->